package com.sun.org.apache.xalan.internal.xsltc;

import java.util.Map;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;
import com.sun.org.apache.xml.internal.serializer.SerializationHandler;
import com.sun.org.apache.xml.internal.dtm.DTMAxisIterator;

public interface DOM
{
    public static final int FIRST_TYPE = 0;
    public static final int NO_TYPE = -1;
    public static final int NULL = 0;
    public static final int RETURN_CURRENT = 0;
    public static final int RETURN_PARENT = 1;
    public static final int SIMPLE_RTF = 0;
    public static final int ADAPTIVE_RTF = 1;
    public static final int TREE_RTF = 2;
    
    public abstract DTMAxisIterator getIterator();
    
    public abstract String getStringValue();
    
    public abstract DTMAxisIterator getChildren(int p0);
    
    public abstract DTMAxisIterator getTypedChildren(int p0);
    
    public abstract DTMAxisIterator getAxisIterator(int p0);
    
    public abstract DTMAxisIterator getTypedAxisIterator(int p0, int p1);
    
    public abstract DTMAxisIterator getNthDescendant(int p0, int p1, boolean p2);
    
    public abstract DTMAxisIterator getNamespaceAxisIterator(int p0, int p1);
    
    public abstract DTMAxisIterator getNodeValueIterator(DTMAxisIterator p0, int p1, String p2, boolean p3);
    
    public abstract DTMAxisIterator orderNodes(DTMAxisIterator p0, int p1);
    
    public abstract String getNodeName(int p0);
    
    public abstract String getNodeNameX(int p0);
    
    public abstract String getNamespaceName(int p0);
    
    public abstract int getExpandedTypeID(int p0);
    
    public abstract int getNamespaceType(int p0);
    
    public abstract int getParent(int p0);
    
    public abstract int getAttributeNode(int p0, int p1);
    
    public abstract String getStringValueX(int p0);
    
    public abstract void copy(int p0, SerializationHandler p1) throws TransletException;
    
    public abstract void copy(DTMAxisIterator p0, SerializationHandler p1) throws TransletException;
    
    public abstract String shallowCopy(int p0, SerializationHandler p1) throws TransletException;
    
    public abstract boolean lessThan(int p0, int p1);
    
    public abstract void characters(int p0, SerializationHandler p1) throws TransletException;
    
    public abstract Node makeNode(int p0);
    
    public abstract Node makeNode(DTMAxisIterator p0);
    
    public abstract NodeList makeNodeList(int p0);
    
    public abstract NodeList makeNodeList(DTMAxisIterator p0);
    
    public abstract String getLanguage(int p0);
    
    public abstract int getSize();
    
    public abstract String getDocumentURI(int p0);
    
    public abstract void setFilter(StripFilter p0);
    
    public abstract void setupMapping(String[] p0, String[] p1, int[] p2, String[] p3);
    
    public abstract boolean isElement(int p0);
    
    public abstract boolean isAttribute(int p0);
    
    public abstract String lookupNamespace(int p0, String p1) throws TransletException;
    
    public abstract int getNodeIdent(int p0);
    
    public abstract int getNodeHandle(int p0);
    
    public abstract DOM getResultTreeFrag(int p0, int p1);
    
    public abstract DOM getResultTreeFrag(int p0, int p1, boolean p2);
    
    public abstract SerializationHandler getOutputDomBuilder();
    
    public abstract int getNSType(int p0);
    
    public abstract int getDocument();
    
    public abstract String getUnparsedEntityURI(String p0);
    
    public abstract Map<String, Integer> getElementsWithIDs();
    
    public abstract void release();
}
